/*
 *  Copyright  2000-2003 sechsta sinn.  All Rights Reserved.
 *
 *  Questions and comments to:
 *       <mailto:info@sechsta-sinn.de>
 *       <http://www.sechsta-sinn.de/>
 */

#ifndef LOG_H
#define LOG_H

#include <fstream>
#include <ios>

// --------------------------------------------------------------------------------
class CLog
{
public:
	CLog( const char* pszFileName );

	CLog& operator<< ( const char* s );
	CLog& operator<< ( char* s );
	CLog& operator<< ( char c );
	CLog& operator<< ( short n );
	CLog& operator<< ( unsigned short n);
	CLog& operator<< ( int n );
	CLog& operator<< ( unsigned int n );
	CLog& operator<< ( long n );
	CLog& operator<< ( unsigned long n );
	CLog& operator<< ( float n );
	CLog& operator<< ( double n );
	CLog& operator<< ( long double n );
	CLog& operator<< ( void* n );

private:
	std::ofstream m_clStream;
	std::string m_strFileName;
};

#define ENDL "\n"

extern CLog LOG;

#endif