/*
 *  Copyright  2003 Matthias Gall.  All Rights Reserved.
 *
 *  Questions and comments to:
 *       <mailto:matthias@sechsta-sinn.de>
 *       <http://www.sechsta-sinn.de/>
 */

#ifndef GAMEMANAGER_H
#define GAMEMANAGER_H

// ---------------------------------------------------------------------------
#include "Types.h"
#include "GameState.h"
#include "GameStateFactory.h"

// ---------------------------------------------------------------------------
class CGameManager
{
public:
	static CGameManager* GetInstance();
	static void DestroyInstance();

	void Initialize();
	void Uninitialize();

	void BeginFrame();
	void Idle();
	void EndFrame();

	void SetGameState( CGameStateFactory::eGameState eGS );

private:
	CGameManager();
	~CGameManager();

	static CGameManager* m_pInstance;

	IGameState* m_pCurrentGameState;
	CGameStateFactory::eGameState m_eCurrentGameState;

	DWORD m_dwFrameStart;
	DWORD m_dwFrameTime;
};

#define GAMEMANAGER CGameManager::GetInstance()

#endif