/*
 *  Copyright  2003 Matthias Gall.  All Rights Reserved.
 *
 *  Questions and comments to:
 *       <mailto:matthias@sechsta-sinn.de>
 *       <http://www.sechsta-sinn.de/>
 */

#include "Starfield.h"
#include <SDL.h>
#include <stdlib.h>

// ---------------------------------------------------------------------------
extern SDL_Surface* g_pBackSurface;

// ---------------------------------------------------------------------------
CStarfield::CStarfield()
:	m_fSpeed( 1.0f )
{
}

// ---------------------------------------------------------------------------
void CStarfield::Initialize()
{
	for( int i = 0; i < NUM_STARS; ++i )
	{
		m_aclStars[ i ].m_fX = (float)( rand() % 800 );
		m_aclStars[ i ].m_fY = (float)( rand() % 600 );
		m_aclStars[ i ].m_fZ = (float)( rand() % 256 );
	}
}

// ---------------------------------------------------------------------------
void CStarfield::Idle( DWORD dwDeltaTime )
{
	for( int i = 0; i < NUM_STARS; ++i )
	{
		m_aclStars[ i ].m_fX -= ( (float)dwDeltaTime / 10.0f * m_aclStars[ i ].m_fZ / 25.5f * m_fSpeed );

		if( m_aclStars[ i ].m_fX < 0.0f )
		{
			m_aclStars[ i ].m_fX = 800.0f;
			m_aclStars[ i ].m_fY = (float)( rand() % 600 );
			m_aclStars[ i ].m_fZ = (float)( rand() % 256 );
		}
	}

	if( SDL_LockSurface( g_pBackSurface ) == 0 )
	{
		for( int i = 0; i < NUM_STARS; ++i )
		{
			WORD wColor = SDL_MapRGB( g_pBackSurface->format, (BYTE)m_aclStars[ i ].m_fZ, (BYTE)m_aclStars[ i ].m_fZ, (BYTE)m_aclStars[ i ].m_fZ );
			( (WORD*)g_pBackSurface->pixels )[ (WORD)m_aclStars[ i ].m_fY * 800 + (WORD)m_aclStars[ i ].m_fX ] = wColor;
		}

		SDL_UnlockSurface( g_pBackSurface );
	}
}

// ---------------------------------------------------------------------------
void CStarfield::SetSpeed( const float fSpeed )
{
	m_fSpeed = fSpeed;
}

// ---------------------------------------------------------------------------
float CStarfield::GetSpeed() const
{
	return m_fSpeed;
}
